Code

Merge branch 'maint'
[git.git] / t / test-lib.sh
1 #!/bin/sh
2 #
3 # Copyright (c) 2005 Junio C Hamano
4 #
5 # This program is free software: you can redistribute it and/or modify
6 # it under the terms of the GNU General Public License as published by
7 # the Free Software Foundation, either version 2 of the License, or
8 # (at your option) any later version.
9 #
10 # This program is distributed in the hope that it will be useful,
11 # but WITHOUT ANY WARRANTY; without even the implied warranty of
12 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
13 # GNU General Public License for more details.
14 #
15 # You should have received a copy of the GNU General Public License
16 # along with this program.  If not, see http://www.gnu.org/licenses/ .
18 # if --tee was passed, write the output not only to the terminal, but
19 # additionally to the file test-results/$BASENAME.out, too.
20 case "$GIT_TEST_TEE_STARTED, $* " in
21 done,*)
22         # do not redirect again
23         ;;
24 *' --tee '*|*' --va'*)
25         mkdir -p test-results
26         BASE=test-results/$(basename "$0" .sh)
27         (GIT_TEST_TEE_STARTED=done ${SHELL-sh} "$0" "$@" 2>&1;
28          echo $? > $BASE.exit) | tee $BASE.out
29         test "$(cat $BASE.exit)" = 0
30         exit
31         ;;
32 esac
34 # Keep the original TERM for say_color
35 ORIGINAL_TERM=$TERM
37 # For repeatability, reset the environment to known value.
38 LANG=C
39 LC_ALL=C
40 PAGER=cat
41 TZ=UTC
42 TERM=dumb
43 export LANG LC_ALL PAGER TERM TZ
44 EDITOR=:
45 unset VISUAL
46 unset GIT_EDITOR
47 unset AUTHOR_DATE
48 unset AUTHOR_EMAIL
49 unset AUTHOR_NAME
50 unset COMMIT_AUTHOR_EMAIL
51 unset COMMIT_AUTHOR_NAME
52 unset EMAIL
53 unset GIT_ALTERNATE_OBJECT_DIRECTORIES
54 unset GIT_AUTHOR_DATE
55 GIT_AUTHOR_EMAIL=author@example.com
56 GIT_AUTHOR_NAME='A U Thor'
57 unset GIT_COMMITTER_DATE
58 GIT_COMMITTER_EMAIL=committer@example.com
59 GIT_COMMITTER_NAME='C O Mitter'
60 unset GIT_DIFF_OPTS
61 unset GIT_DIR
62 unset GIT_WORK_TREE
63 unset GIT_EXTERNAL_DIFF
64 unset GIT_INDEX_FILE
65 unset GIT_OBJECT_DIRECTORY
66 unset GIT_CEILING_DIRECTORIES
67 unset SHA1_FILE_DIRECTORIES
68 unset SHA1_FILE_DIRECTORY
69 unset GIT_NOTES_REF
70 unset GIT_NOTES_DISPLAY_REF
71 unset GIT_NOTES_REWRITE_REF
72 unset GIT_NOTES_REWRITE_MODE
73 GIT_MERGE_VERBOSITY=5
74 export GIT_MERGE_VERBOSITY
75 export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
76 export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
77 export EDITOR
79 # Protect ourselves from common misconfiguration to export
80 # CDPATH into the environment
81 unset CDPATH
83 unset GREP_OPTIONS
85 case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
86         1|2|true)
87                 echo "* warning: Some tests will not work if GIT_TRACE" \
88                         "is set as to trace on STDERR ! *"
89                 echo "* warning: Please set GIT_TRACE to something" \
90                         "other than 1, 2 or true ! *"
91                 ;;
92 esac
94 # Convenience
95 #
96 # A regexp to match 5 and 40 hexdigits
97 _x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
98 _x40="$_x05$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
100 # Each test should start with something like this, after copyright notices:
102 # test_description='Description of this test...
103 # This test checks if command xyzzy does the right thing...
104 # '
105 # . ./test-lib.sh
106 [ "x$ORIGINAL_TERM" != "xdumb" ] && (
107                 TERM=$ORIGINAL_TERM &&
108                 export TERM &&
109                 [ -t 1 ] &&
110                 tput bold >/dev/null 2>&1 &&
111                 tput setaf 1 >/dev/null 2>&1 &&
112                 tput sgr0 >/dev/null 2>&1
113         ) &&
114         color=t
116 while test "$#" -ne 0
117 do
118         case "$1" in
119         -d|--d|--de|--deb|--debu|--debug)
120                 debug=t; shift ;;
121         -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
122                 immediate=t; shift ;;
123         -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
124                 GIT_TEST_LONG=t; export GIT_TEST_LONG; shift ;;
125         -h|--h|--he|--hel|--help)
126                 help=t; shift ;;
127         -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
128                 verbose=t; shift ;;
129         -q|--q|--qu|--qui|--quie|--quiet)
130                 # Ignore --quiet under a TAP::Harness. Saying how many tests
131                 # passed without the ok/not ok details is always an error.
132                 test -z "$HARNESS_ACTIVE" && quiet=t; shift ;;
133         --with-dashes)
134                 with_dashes=t; shift ;;
135         --no-color)
136                 color=; shift ;;
137         --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
138                 valgrind=t; verbose=t; shift ;;
139         --tee)
140                 shift ;; # was handled already
141         --root=*)
142                 root=$(expr "z$1" : 'z[^=]*=\(.*\)')
143                 shift ;;
144         *)
145                 echo "error: unknown test option '$1'" >&2; exit 1 ;;
146         esac
147 done
149 if test -n "$color"; then
150         say_color () {
151                 (
152                 TERM=$ORIGINAL_TERM
153                 export TERM
154                 case "$1" in
155                         error) tput bold; tput setaf 1;; # bold red
156                         skip)  tput bold; tput setaf 2;; # bold green
157                         pass)  tput setaf 2;;            # green
158                         info)  tput setaf 3;;            # brown
159                         *) test -n "$quiet" && return;;
160                 esac
161                 shift
162                 printf "%s" "$*"
163                 tput sgr0
164                 echo
165                 )
166         }
167 else
168         say_color() {
169                 test -z "$1" && test -n "$quiet" && return
170                 shift
171                 echo "$*"
172         }
173 fi
175 error () {
176         say_color error "error: $*"
177         GIT_EXIT_OK=t
178         exit 1
181 say () {
182         say_color info "$*"
185 test "${test_description}" != "" ||
186 error "Test script did not set test_description."
188 if test "$help" = "t"
189 then
190         echo "$test_description"
191         exit 0
192 fi
194 exec 5>&1
195 if test "$verbose" = "t"
196 then
197         exec 4>&2 3>&1
198 else
199         exec 4>/dev/null 3>/dev/null
200 fi
202 test_failure=0
203 test_count=0
204 test_fixed=0
205 test_broken=0
206 test_success=0
208 test_external_has_tap=0
210 die () {
211         code=$?
212         if test -n "$GIT_EXIT_OK"
213         then
214                 exit $code
215         else
216                 echo >&5 "FATAL: Unexpected exit with code $code"
217                 exit 1
218         fi
221 GIT_EXIT_OK=
222 trap 'die' EXIT
224 # The semantics of the editor variables are that of invoking
225 # sh -c "$EDITOR \"$@\"" files ...
227 # If our trash directory contains shell metacharacters, they will be
228 # interpreted if we just set $EDITOR directly, so do a little dance with
229 # environment variables to work around this.
231 # In particular, quoting isn't enough, as the path may contain the same quote
232 # that we're using.
233 test_set_editor () {
234         FAKE_EDITOR="$1"
235         export FAKE_EDITOR
236         EDITOR='"$FAKE_EDITOR"'
237         export EDITOR
240 test_decode_color () {
241         sed     -e 's/.\[1m/<WHITE>/g' \
242                 -e 's/.\[31m/<RED>/g' \
243                 -e 's/.\[32m/<GREEN>/g' \
244                 -e 's/.\[33m/<YELLOW>/g' \
245                 -e 's/.\[34m/<BLUE>/g' \
246                 -e 's/.\[35m/<MAGENTA>/g' \
247                 -e 's/.\[36m/<CYAN>/g' \
248                 -e 's/.\[m/<RESET>/g'
251 q_to_nul () {
252         perl -pe 'y/Q/\000/'
255 q_to_cr () {
256         tr Q '\015'
259 q_to_tab () {
260         tr Q '\011'
263 append_cr () {
264         sed -e 's/$/Q/' | tr Q '\015'
267 remove_cr () {
268         tr '\015' Q | sed -e 's/Q$//'
271 test_tick () {
272         if test -z "${test_tick+set}"
273         then
274                 test_tick=1112911993
275         else
276                 test_tick=$(($test_tick + 60))
277         fi
278         GIT_COMMITTER_DATE="$test_tick -0700"
279         GIT_AUTHOR_DATE="$test_tick -0700"
280         export GIT_COMMITTER_DATE GIT_AUTHOR_DATE
283 # Call test_commit with the arguments "<message> [<file> [<contents>]]"
285 # This will commit a file with the given contents and the given commit
286 # message.  It will also add a tag with <message> as name.
288 # Both <file> and <contents> default to <message>.
290 test_commit () {
291         file=${2:-"$1.t"}
292         echo "${3-$1}" > "$file" &&
293         git add "$file" &&
294         test_tick &&
295         git commit -m "$1" &&
296         git tag "$1"
299 # Call test_merge with the arguments "<message> <commit>", where <commit>
300 # can be a tag pointing to the commit-to-merge.
302 test_merge () {
303         test_tick &&
304         git merge -m "$1" "$2" &&
305         git tag "$1"
308 # This function helps systems where core.filemode=false is set.
309 # Use it instead of plain 'chmod +x' to set or unset the executable bit
310 # of a file in the working directory and add it to the index.
312 test_chmod () {
313         chmod "$@" &&
314         git update-index --add "--chmod=$@"
317 # Use test_set_prereq to tell that a particular prerequisite is available.
318 # The prerequisite can later be checked for in two ways:
320 # - Explicitly using test_have_prereq.
322 # - Implicitly by specifying the prerequisite tag in the calls to
323 #   test_expect_{success,failure,code}.
325 # The single parameter is the prerequisite tag (a simple word, in all
326 # capital letters by convention).
328 test_set_prereq () {
329         satisfied="$satisfied$1 "
331 satisfied=" "
333 test_have_prereq () {
334         # prerequisites can be concatenated with ','
335         save_IFS=$IFS
336         IFS=,
337         set -- $*
338         IFS=$save_IFS
340         total_prereq=0
341         ok_prereq=0
342         missing_prereq=
344         for prerequisite
345         do
346                 total_prereq=$(($total_prereq + 1))
347                 case $satisfied in
348                 *" $prerequisite "*)
349                         ok_prereq=$(($ok_prereq + 1))
350                         ;;
351                 *)
352                         # Keep a list of missing prerequisites
353                         if test -z "$missing_prereq"
354                         then
355                                 missing_prereq=$prerequisite
356                         else
357                                 missing_prereq="$prerequisite,$missing_prereq"
358                         fi
359                 esac
360         done
362         test $total_prereq = $ok_prereq
365 # You are not expected to call test_ok_ and test_failure_ directly, use
366 # the text_expect_* functions instead.
368 test_ok_ () {
369         test_success=$(($test_success + 1))
370         say_color "" "ok $test_count - $@"
373 test_failure_ () {
374         test_failure=$(($test_failure + 1))
375         say_color error "not ok - $test_count $1"
376         shift
377         echo "$@" | sed -e 's/^/#       /'
378         test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
381 test_known_broken_ok_ () {
382         test_fixed=$(($test_fixed+1))
383         say_color "" "ok $test_count - $@ # TODO known breakage"
386 test_known_broken_failure_ () {
387         test_broken=$(($test_broken+1))
388         say_color skip "not ok $test_count - $@ # TODO known breakage"
391 test_debug () {
392         test "$debug" = "" || eval "$1"
395 test_run_ () {
396         test_cleanup=:
397         eval >&3 2>&4 "$1"
398         eval_ret=$?
399         eval >&3 2>&4 "$test_cleanup"
400         if test "$verbose" = "t" && test -n "$HARNESS_ACTIVE"; then
401                 echo ""
402         fi
403         return 0
406 test_skip () {
407         test_count=$(($test_count+1))
408         to_skip=
409         for skp in $GIT_SKIP_TESTS
410         do
411                 case $this_test.$test_count in
412                 $skp)
413                         to_skip=t
414                         break
415                 esac
416         done
417         if test -z "$to_skip" && test -n "$prereq" &&
418            ! test_have_prereq "$prereq"
419         then
420                 to_skip=t
421         fi
422         case "$to_skip" in
423         t)
424                 of_prereq=
425                 if test "$missing_prereq" != "$prereq"
426                 then
427                         of_prereq=" of $prereq"
428                 fi
430                 say_color skip >&3 "skipping test: $@"
431                 say_color skip "ok $test_count # skip $1 (missing $missing_prereq${of_prereq})"
432                 : true
433                 ;;
434         *)
435                 false
436                 ;;
437         esac
440 test_expect_failure () {
441         test "$#" = 3 && { prereq=$1; shift; } || prereq=
442         test "$#" = 2 ||
443         error "bug in the test script: not 2 or 3 parameters to test-expect-failure"
444         if ! test_skip "$@"
445         then
446                 say >&3 "checking known breakage: $2"
447                 test_run_ "$2"
448                 if [ "$?" = 0 -a "$eval_ret" = 0 ]
449                 then
450                         test_known_broken_ok_ "$1"
451                 else
452                         test_known_broken_failure_ "$1"
453                 fi
454         fi
455         echo >&3 ""
458 test_expect_success () {
459         test "$#" = 3 && { prereq=$1; shift; } || prereq=
460         test "$#" = 2 ||
461         error "bug in the test script: not 2 or 3 parameters to test-expect-success"
462         if ! test_skip "$@"
463         then
464                 say >&3 "expecting success: $2"
465                 test_run_ "$2"
466                 if [ "$?" = 0 -a "$eval_ret" = 0 ]
467                 then
468                         test_ok_ "$1"
469                 else
470                         test_failure_ "$@"
471                 fi
472         fi
473         echo >&3 ""
476 test_expect_code () {
477         test "$#" = 4 && { prereq=$1; shift; } || prereq=
478         test "$#" = 3 ||
479         error "bug in the test script: not 3 or 4 parameters to test-expect-code"
480         if ! test_skip "$@"
481         then
482                 say >&3 "expecting exit code $1: $3"
483                 test_run_ "$3"
484                 if [ "$?" = 0 -a "$eval_ret" = "$1" ]
485                 then
486                         test_ok_ "$2"
487                 else
488                         test_failure_ "$@"
489                 fi
490         fi
491         echo >&3 ""
494 # test_external runs external test scripts that provide continuous
495 # test output about their progress, and succeeds/fails on
496 # zero/non-zero exit code.  It outputs the test output on stdout even
497 # in non-verbose mode, and announces the external script with "# run
498 # <n>: ..." before running it.  When providing relative paths, keep in
499 # mind that all scripts run in "trash directory".
500 # Usage: test_external description command arguments...
501 # Example: test_external 'Perl API' perl ../path/to/test.pl
502 test_external () {
503         test "$#" = 4 && { prereq=$1; shift; } || prereq=
504         test "$#" = 3 ||
505         error >&5 "bug in the test script: not 3 or 4 parameters to test_external"
506         descr="$1"
507         shift
508         if ! test_skip "$descr" "$@"
509         then
510                 # Announce the script to reduce confusion about the
511                 # test output that follows.
512                 say_color "" "# run $test_count: $descr ($*)"
513                 # Export TEST_DIRECTORY, TRASH_DIRECTORY and GIT_TEST_LONG
514                 # to be able to use them in script
515                 export TEST_DIRECTORY TRASH_DIRECTORY GIT_TEST_LONG
516                 # Run command; redirect its stderr to &4 as in
517                 # test_run_, but keep its stdout on our stdout even in
518                 # non-verbose mode.
519                 "$@" 2>&4
520                 if [ "$?" = 0 ]
521                 then
522                         if test $test_external_has_tap -eq 0; then
523                                 test_ok_ "$descr"
524                         else
525                                 say_color "" "# test_external test $descr was ok"
526                                 test_success=$(($test_success + 1))
527                         fi
528                 else
529                         if test $test_external_has_tap -eq 0; then
530                                 test_failure_ "$descr" "$@"
531                         else
532                                 say_color error "# test_external test $descr failed: $@"
533                                 test_failure=$(($test_failure + 1))
534                         fi
535                 fi
536         fi
539 # Like test_external, but in addition tests that the command generated
540 # no output on stderr.
541 test_external_without_stderr () {
542         # The temporary file has no (and must have no) security
543         # implications.
544         tmp="$TMPDIR"; if [ -z "$tmp" ]; then tmp=/tmp; fi
545         stderr="$tmp/git-external-stderr.$$.tmp"
546         test_external "$@" 4> "$stderr"
547         [ -f "$stderr" ] || error "Internal error: $stderr disappeared."
548         descr="no stderr: $1"
549         shift
550         say >&3 "# expecting no stderr from previous command"
551         if [ ! -s "$stderr" ]; then
552                 rm "$stderr"
554                 if test $test_external_has_tap -eq 0; then
555                         test_ok_ "$descr"
556                 else
557                         say_color "" "# test_external_without_stderr test $descr was ok"
558                         test_success=$(($test_success + 1))
559                 fi
560         else
561                 if [ "$verbose" = t ]; then
562                         output=`echo; echo "# Stderr is:"; cat "$stderr"`
563                 else
564                         output=
565                 fi
566                 # rm first in case test_failure exits.
567                 rm "$stderr"
568                 if test $test_external_has_tap -eq 0; then
569                         test_failure_ "$descr" "$@" "$output"
570                 else
571                         say_color error "# test_external_without_stderr test $descr failed: $@: $output"
572                         test_failure=$(($test_failure + 1))
573                 fi
574         fi
577 # debugging-friendly alternatives to "test [-f|-d|-e]"
578 # The commands test the existence or non-existence of $1. $2 can be
579 # given to provide a more precise diagnosis.
580 test_path_is_file () {
581         if ! [ -f "$1" ]
582         then
583                 echo "File $1 doesn't exist. $*"
584                 false
585         fi
588 test_path_is_dir () {
589         if ! [ -d "$1" ]
590         then
591                 echo "Directory $1 doesn't exist. $*"
592                 false
593         fi
596 test_path_is_missing () {
597         if [ -e "$1" ]
598         then
599                 echo "Path exists:"
600                 ls -ld "$1"
601                 if [ $# -ge 1 ]; then
602                         echo "$*"
603                 fi
604                 false
605         fi
609 # This is not among top-level (test_expect_success | test_expect_failure)
610 # but is a prefix that can be used in the test script, like:
612 #       test_expect_success 'complain and die' '
613 #           do something &&
614 #           do something else &&
615 #           test_must_fail git checkout ../outerspace
616 #       '
618 # Writing this as "! git checkout ../outerspace" is wrong, because
619 # the failure could be due to a segv.  We want a controlled failure.
621 test_must_fail () {
622         "$@"
623         test $? -gt 0 -a $? -le 129 -o $? -gt 192
626 # Similar to test_must_fail, but tolerates success, too.  This is
627 # meant to be used in contexts like:
629 #       test_expect_success 'some command works without configuration' '
630 #               test_might_fail git config --unset all.configuration &&
631 #               do something
632 #       '
634 # Writing "git config --unset all.configuration || :" would be wrong,
635 # because we want to notice if it fails due to segv.
637 test_might_fail () {
638         "$@"
639         test $? -ge 0 -a $? -le 129 -o $? -gt 192
642 # test_cmp is a helper function to compare actual and expected output.
643 # You can use it like:
645 #       test_expect_success 'foo works' '
646 #               echo expected >expected &&
647 #               foo >actual &&
648 #               test_cmp expected actual
649 #       '
651 # This could be written as either "cmp" or "diff -u", but:
652 # - cmp's output is not nearly as easy to read as diff -u
653 # - not all diff versions understand "-u"
655 test_cmp() {
656         $GIT_TEST_CMP "$@"
659 # This function can be used to schedule some commands to be run
660 # unconditionally at the end of the test to restore sanity:
662 #       test_expect_success 'test core.capslock' '
663 #               git config core.capslock true &&
664 #               test_when_finished "git config --unset core.capslock" &&
665 #               hello world
666 #       '
668 # That would be roughly equivalent to
670 #       test_expect_success 'test core.capslock' '
671 #               git config core.capslock true &&
672 #               hello world
673 #               git config --unset core.capslock
674 #       '
676 # except that the greeting and config --unset must both succeed for
677 # the test to pass.
679 test_when_finished () {
680         test_cleanup="{ $*
681                 } && (exit \"\$eval_ret\"); eval_ret=\$?; $test_cleanup"
684 # Most tests can use the created repository, but some may need to create more.
685 # Usage: test_create_repo <directory>
686 test_create_repo () {
687         test "$#" = 1 ||
688         error "bug in the test script: not 1 parameter to test-create-repo"
689         repo="$1"
690         mkdir -p "$repo"
691         (
692                 cd "$repo" || error "Cannot setup test environment"
693                 "$GIT_EXEC_PATH/git-init" "--template=$GIT_BUILD_DIR/templates/blt/" >&3 2>&4 ||
694                 error "cannot run git init -- have you built things yet?"
695                 mv .git/hooks .git/hooks-disabled
696         ) || exit
699 test_done () {
700         GIT_EXIT_OK=t
702         if test -z "$HARNESS_ACTIVE"; then
703                 test_results_dir="$TEST_DIRECTORY/test-results"
704                 mkdir -p "$test_results_dir"
705                 test_results_path="$test_results_dir/${0%.sh}-$$.counts"
707                 echo "total $test_count" >> $test_results_path
708                 echo "success $test_success" >> $test_results_path
709                 echo "fixed $test_fixed" >> $test_results_path
710                 echo "broken $test_broken" >> $test_results_path
711                 echo "failed $test_failure" >> $test_results_path
712                 echo "" >> $test_results_path
713         fi
715         if test "$test_fixed" != 0
716         then
717                 say_color pass "# fixed $test_fixed known breakage(s)"
718         fi
719         if test "$test_broken" != 0
720         then
721                 say_color error "# still have $test_broken known breakage(s)"
722                 msg="remaining $(($test_count-$test_broken)) test(s)"
723         else
724                 msg="$test_count test(s)"
725         fi
726         case "$test_failure" in
727         0)
728                 # Maybe print SKIP message
729                 [ -z "$skip_all" ] || skip_all=" # SKIP $skip_all"
731                 if test $test_external_has_tap -eq 0; then
732                         say_color pass "# passed all $msg"
733                         say "1..$test_count$skip_all"
734                 fi
736                 test -d "$remove_trash" &&
737                 cd "$(dirname "$remove_trash")" &&
738                 rm -rf "$(basename "$remove_trash")"
740                 exit 0 ;;
742         *)
743                 if test $test_external_has_tap -eq 0; then
744                         say_color error "# failed $test_failure among $msg"
745                         say "1..$test_count"
746                 fi
748                 exit 1 ;;
750         esac
753 # Test the binaries we have just built.  The tests are kept in
754 # t/ subdirectory and are run in 'trash directory' subdirectory.
755 if test -z "$TEST_DIRECTORY"
756 then
757         # We allow tests to override this, in case they want to run tests
758         # outside of t/, e.g. for running tests on the test library
759         # itself.
760         TEST_DIRECTORY=$(pwd)
761 fi
762 GIT_BUILD_DIR="$TEST_DIRECTORY"/..
764 if test -n "$valgrind"
765 then
766         make_symlink () {
767                 test -h "$2" &&
768                 test "$1" = "$(readlink "$2")" || {
769                         # be super paranoid
770                         if mkdir "$2".lock
771                         then
772                                 rm -f "$2" &&
773                                 ln -s "$1" "$2" &&
774                                 rm -r "$2".lock
775                         else
776                                 while test -d "$2".lock
777                                 do
778                                         say "Waiting for lock on $2."
779                                         sleep 1
780                                 done
781                         fi
782                 }
783         }
785         make_valgrind_symlink () {
786                 # handle only executables
787                 test -x "$1" || return
789                 base=$(basename "$1")
790                 symlink_target=$GIT_BUILD_DIR/$base
791                 # do not override scripts
792                 if test -x "$symlink_target" &&
793                     test ! -d "$symlink_target" &&
794                     test "#!" != "$(head -c 2 < "$symlink_target")"
795                 then
796                         symlink_target=../valgrind.sh
797                 fi
798                 case "$base" in
799                 *.sh|*.perl)
800                         symlink_target=../unprocessed-script
801                 esac
802                 # create the link, or replace it if it is out of date
803                 make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
804         }
806         # override all git executables in TEST_DIRECTORY/..
807         GIT_VALGRIND=$TEST_DIRECTORY/valgrind
808         mkdir -p "$GIT_VALGRIND"/bin
809         for file in $GIT_BUILD_DIR/git* $GIT_BUILD_DIR/test-*
810         do
811                 make_valgrind_symlink $file
812         done
813         OLDIFS=$IFS
814         IFS=:
815         for path in $PATH
816         do
817                 ls "$path"/git-* 2> /dev/null |
818                 while read file
819                 do
820                         make_valgrind_symlink "$file"
821                 done
822         done
823         IFS=$OLDIFS
824         PATH=$GIT_VALGRIND/bin:$PATH
825         GIT_EXEC_PATH=$GIT_VALGRIND/bin
826         export GIT_VALGRIND
827 elif test -n "$GIT_TEST_INSTALLED" ; then
828         GIT_EXEC_PATH=$($GIT_TEST_INSTALLED/git --exec-path)  ||
829         error "Cannot run git from $GIT_TEST_INSTALLED."
830         PATH=$GIT_TEST_INSTALLED:$GIT_BUILD_DIR:$PATH
831         GIT_EXEC_PATH=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
832 else # normal case, use ../bin-wrappers only unless $with_dashes:
833         git_bin_dir="$GIT_BUILD_DIR/bin-wrappers"
834         if ! test -x "$git_bin_dir/git" ; then
835                 if test -z "$with_dashes" ; then
836                         say "$git_bin_dir/git is not executable; using GIT_EXEC_PATH"
837                 fi
838                 with_dashes=t
839         fi
840         PATH="$git_bin_dir:$PATH"
841         GIT_EXEC_PATH=$GIT_BUILD_DIR
842         if test -n "$with_dashes" ; then
843                 PATH="$GIT_BUILD_DIR:$PATH"
844         fi
845 fi
846 GIT_TEMPLATE_DIR="$GIT_BUILD_DIR"/templates/blt
847 unset GIT_CONFIG
848 GIT_CONFIG_NOSYSTEM=1
849 GIT_CONFIG_NOGLOBAL=1
850 export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_CONFIG_NOGLOBAL
852 . "$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
854 if test -z "$GIT_TEST_CMP"
855 then
856         if test -n "$GIT_TEST_CMP_USE_COPIED_CONTEXT"
857         then
858                 GIT_TEST_CMP="$DIFF -c"
859         else
860                 GIT_TEST_CMP="$DIFF -u"
861         fi
862 fi
864 GITPERLLIB="$GIT_BUILD_DIR"/perl/blib/lib:"$GIT_BUILD_DIR"/perl/blib/arch/auto/Git
865 export GITPERLLIB
866 test -d "$GIT_BUILD_DIR"/templates/blt || {
867         error "You haven't built things yet, have you?"
870 if test -z "$GIT_TEST_INSTALLED" && test -z "$NO_PYTHON"
871 then
872         GITPYTHONLIB="$GIT_BUILD_DIR/git_remote_helpers/build/lib"
873         export GITPYTHONLIB
874         test -d "$GIT_BUILD_DIR"/git_remote_helpers/build || {
875                 error "You haven't built git_remote_helpers yet, have you?"
876         }
877 fi
879 if ! test -x "$GIT_BUILD_DIR"/test-chmtime; then
880         echo >&2 'You need to build test-chmtime:'
881         echo >&2 'Run "make test-chmtime" in the source (toplevel) directory'
882         exit 1
883 fi
885 # Test repository
886 test="trash directory.$(basename "$0" .sh)"
887 test -n "$root" && test="$root/$test"
888 case "$test" in
889 /*) TRASH_DIRECTORY="$test" ;;
890  *) TRASH_DIRECTORY="$TEST_DIRECTORY/$test" ;;
891 esac
892 test ! -z "$debug" || remove_trash=$TRASH_DIRECTORY
893 rm -fr "$test" || {
894         GIT_EXIT_OK=t
895         echo >&5 "FATAL: Cannot prepare test area"
896         exit 1
899 test_create_repo "$test"
900 # Use -P to resolve symlinks in our working directory so that the cwd
901 # in subprocesses like git equals our $PWD (for pathname comparisons).
902 cd -P "$test" || exit 1
904 HOME=$(pwd)
905 export HOME
907 this_test=${0##*/}
908 this_test=${this_test%%-*}
909 for skp in $GIT_SKIP_TESTS
910 do
911         case "$this_test" in
912         $skp)
913                 say_color skip >&3 "skipping test $this_test altogether"
914                 skip_all="skip all tests in $this_test"
915                 test_done
916         esac
917 done
919 # Provide an implementation of the 'yes' utility
920 yes () {
921         if test $# = 0
922         then
923                 y=y
924         else
925                 y="$*"
926         fi
928         while echo "$y"
929         do
930                 :
931         done
934 # Fix some commands on Windows
935 case $(uname -s) in
936 *MINGW*)
937         # Windows has its own (incompatible) sort and find
938         sort () {
939                 /usr/bin/sort "$@"
940         }
941         find () {
942                 /usr/bin/find "$@"
943         }
944         sum () {
945                 md5sum "$@"
946         }
947         # git sees Windows-style pwd
948         pwd () {
949                 builtin pwd -W
950         }
951         # no POSIX permissions
952         # backslashes in pathspec are converted to '/'
953         # exec does not inherit the PID
954         ;;
955 *)
956         test_set_prereq POSIXPERM
957         test_set_prereq BSLASHPSPEC
958         test_set_prereq EXECKEEPSPID
959         ;;
960 esac
962 test -z "$NO_PERL" && test_set_prereq PERL
963 test -z "$NO_PYTHON" && test_set_prereq PYTHON
965 # test whether the filesystem supports symbolic links
966 ln -s x y 2>/dev/null && test -h y 2>/dev/null && test_set_prereq SYMLINKS
967 rm -f y
969 # When the tests are run as root, permission tests will report that
970 # things are writable when they shouldn't be.
971 test -w / || test_set_prereq SANITY